using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.ServiceModel;
using System.Text;
using ICS.WCF.Base;
using UFSoft.UBF.Exceptions1;
using UFSoft.UBF.Service;
using UFSoft.UBF.Util.Context;
using UFSoft.UBF.Exceptions;
using UFIDA.ISV.BFRCVApprove;

namespace UFIDA.ISV.BFRCVDelete
{
    public class CustBFRCVDelete
    {

        public static void CustDeleteRCV(List<string> DocList, string OrgID)
        {
            long DocID = 0;
            string EntityType = "";
            #region 服务调用框架结构
            //实例化代理类 
            UFIDAU9PMRcvIDeleteRCVSRVClient client = new UFIDAU9PMRcvIDeleteRCVSRVClient();
            //服务返回结果
            //UFIDAU9PMPOPurchaseOrderData[] returnItems;
            //返回异常信息，目前还没有使用此属性
            UFSoft.UBF.Exceptions.MessageBase[] returnMsg;
            //上下文信息
            object context;
            //传入 参数
            //UFIDAU9PMDTOsOBAPurchaseOrderDTOData[] pOList;
            UFSoft.UBF.Business.BusinessEntity.EntityKey[] docArray = new UFSoft.UBF.Business.BusinessEntity.EntityKey[] { };
            List<UFSoft.UBF.Business.BusinessEntity.EntityKey> docList = new List<UFSoft.UBF.Business.BusinessEntity.EntityKey>();
            try
            {
                foreach (string DocCode in DocList)
                {
                    DataTable dt = GetData(DocCode, OrgID);
                    if (!string.IsNullOrEmpty(dt.Rows[0][0].ToString()) || !string.IsNullOrEmpty(dt.Rows[0][1].ToString()))
                    {
                        DocID = long.Parse(dt.Rows[0][0].ToString());
                        EntityType = dt.Rows[0][1].ToString();
                        //审核完成的单据需要先弃审，后删除
                        if (dt.Rows[0][2].ToString() == "5")
                        {
                            CustBFRCVApprove.CustApproveRec(DocCode, OrgID, "弃审");
                        }
                    }
                    else
                    {
                        throw new Exception("需要删除的单据号不正确!");
                    }

                    UFSoft.UBF.Business.BusinessEntity.EntityKey docinfo = new UFSoft.UBF.Business.BusinessEntity.EntityKey();
                    //给传入参数赋值
                    docinfo.ID = DocID;
                    docList.Add(docinfo);
                    docArray = docList.ToArray();
                }
                //给上下文信息赋值
                context = CreateContextObj(OrgID);
                //pOList = SetPoDtos(U9Info, poInfoList);
                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;
                returnMsg = client.Do(context, docArray);
            }
            catch (Exception ex)
            {
                throw new Exception("删除失败：" + ex.Message);
            }
            #endregion
        }

        private static DataTable GetData(string DocCode, string OrgID)
        {
            string sql = @"select  A.ID,A1.[Code] as [Receivement_RcvDocType_Code],A.Status
from  PM_Receivement as A  
left join [PM_RcvDocType] as A1 on (A.[RcvDocType] = A1.[ID])  
left join [PM_RcvDocType_Trl] as A2 on (A2.SysMlFlag = 'zh-CN') and (A1.[ID] = A2.[ID])
where A.DocNo='" + DocCode + "' AND A.Org='" + OrgID + "'";
            return DBhlper.Query(sql, Appconfig.GetU9ConnStr());
        }

        #region 提取异常信息
        /// <summary>
        /// 提取异常信息
        /// </summary>
        /// <param name="ex"></param>
        private static string GetExceptionMessage(Exception ex)
        {
            string faultMessage = "未知错误，请查看ERP日志！";

            System.TimeoutException timeoutEx = ex as System.TimeoutException;
            if (timeoutEx != null)
            {
                faultMessage = "访问服务超时，请修改配置信息！";
            }
            else
            {
                FaultException<ServiceException> faultEx = ex as FaultException<ServiceException>;
                if (faultEx == null)
                {
                    faultMessage = ex.Message;
                }
                else
                {
                    ServiceException serviceEx = faultEx.Detail;
                    if (serviceEx != null && !string.IsNullOrEmpty(serviceEx.Message)
                        && !serviceEx.Message.Equals("fault", StringComparison.OrdinalIgnoreCase))
                    {
                        // 错误信息在faultEx.Message中，请提取，
                        // 格式为"Fault:料品不能为空，请录入\n 在....."
                        int startIndex = serviceEx.Message.IndexOf(":");
                        int endIndex = serviceEx.Message.IndexOf("\n");
                        if (endIndex == -1)
                            endIndex = serviceEx.Message.Length;
                        if (endIndex > 0 && endIndex > startIndex + 1)
                        {
                            faultMessage = serviceEx.Message.Substring(startIndex + 1, endIndex - startIndex - 1);
                        }
                        else
                        {
                            faultMessage = serviceEx.Message;
                        }
                    }
                }
            }
            return faultMessage;
        }
        #endregion

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", ConfigurationManager.AppSettings["userID"].ToString());
            ns.Add("UserCode", ConfigurationManager.AppSettings["userCode"].ToString());
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion
        public class ReturnValue1//List<rtnPoinfo>
        {
            public bool IsSuccess;
            public string Mes;
            public MessageBase[] poheadList;
        }
    }
}
